=== debian/control ===
Source: lua-torch-torch7
Section: interpreters
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Mo Zhou <cdluminate@gmail.com>
Build-Depends: cmake,
               debhelper (>= 11~),
               dh-lua,
               lua5.1,
# luajit (<= 2.0) suffers from compatibility problem, require higher version
               luajit (>= 2.1.0~beta2),
               lua-torch-cwrap,
               lua-torch-paths,
               libblas-dev | libblas.so,
               liblapack-dev | liblapack.so,
Standards-Version: 4.2.1
Homepage: https://github.com/torch/torch7
Vcs-Browser: https://salsa.debian.org/science-team/lua-torch-torch7
Vcs-Git: https://salsa.debian.org/science-team/lua-torch-torch7.git

# Architecture Note:
# https://github.com/torch/torch7/issues/762#issuecomment-271497176
# supported: amd64 (arm64) armel armhf ppc64el kfreebsd-amd64

Package: lua-torch-torch7
Architecture: amd64 arm64 i386 armel armhf ppc64el kfreebsd-amd64
# NOTE: users are expected to use luajit.
# NOTE: even if upstream supports luajit, 5.1, 5.2 and 5.3
Depends: ${misc:Depends}, ${shlibs:Depends}, luajit | lua5.1 ,
         libtorch-th, libtorch-luat, lua-torch-cwrap,
         lua-torch-paths,
Suggests: luajit
XB-Lua-Versions: ${lua:Versions}
Description: Torch Package for Torch Framework
 Torch is the main package in Torch7 where data structures for
 multi-dimensional tensors and mathematical operations over these
 are defined. Additionally, it provides many utilities for accessing
 files, serializing objects of arbitrary types and other useful utilities.

Package: lua-torch-torch7-dev
Architecture: amd64 arm64 i386 armel armhf ppc64el kfreebsd-amd64
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends},
         lua-torch-torch7 (= ${binary:Version})
XB-Lua-Versions: ${lua:Versions}
Description: Torch Package for Torch Framework (dev)
 Torch is the main package in Torch7 where data structures for
 multi-dimensional tensors and mathematical operations over these
 are defined. Additionally, it provides many utilities for accessing
 files, serializing objects of arbitrary types and other useful utilities.
 .
 This package contains development files.

Package: libtorch-th
Architecture: amd64 arm64 i386 armel armhf ppc64el kfreebsd-amd64
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         libblas3 | libblas.so.3,
         liblapack3 | liblapack.so.3,
Description: libTH.so of Torch Package for Torch Framework
 Torch is the main package in Torch7 where data structures for
 multi-dimensional tensors and mathematical operations over these
 are defined. Additionally, it provides many utilities for accessing
 files, serializing objects of arbitrary types and other useful utilities.
 .
 This package contains libTH.so .

Package: libtorch-th-dev
Architecture: amd64 arm64 i386 armel armhf ppc64el kfreebsd-amd64
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libtorch-th (= ${binary:Version})
Breaks:
 lua-torch-images (<= 0~20170420-g5aa1881-6),
 lua-torch-nn (<= 0~20171002-g8726825+dfsg-3),
 lua-torch-cutorch (<= 0~20170911-g5e9d86c-2),
Description: libTH.so of Torch Package for Torch Framework (dev)
 Torch is the main package in Torch7 where data structures for
 multi-dimensional tensors and mathematical operations over these
 are defined. Additionally, it provides many utilities for accessing
 files, serializing objects of arbitrary types and other useful utilities.
 .
 This package contains development files for libTH.so .

Package: libtorch-luat
Architecture: amd64 arm64 i386 armel armhf ppc64el kfreebsd-amd64
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: libluaT.so of Torch Package for Torch Framework
 Torch is the main package in Torch7 where data structures for
 multi-dimensional tensors and mathematical operations over these
 are defined. Additionally, it provides many utilities for accessing
 files, serializing objects of arbitrary types and other useful utilities.
 .
 This package contains libluaT.so .

Package: libtorch-luat-dev
Architecture: amd64 arm64 i386 armel armhf ppc64el kfreebsd-amd64
Section: libdevel
Depends: ${misc:Depends}, ${shlibs:Depends}, libtorch-luat (= ${binary:Version})
Description: libluaT.so of Torch Package for Torch Framework (dev)
 Torch is the main package in Torch7 where data structures for
 multi-dimensional tensors and mathematical operations over these
 are defined. Additionally, it provides many utilities for accessing
 files, serializing objects of arbitrary types and other useful utilities.
 .
 This package contains development files for libluaT.so .
