=== debian/tests/control ===
Tests: lua.require

Tests: test.torch.unittest
