=== luaT/CMakeLists.txt ===
--- 
+++ 
@@ -9,18 +9,9 @@
 ENDIF()
 
 ADD_LIBRARY(luaT SHARED luaT.h luaT.c)
-
-IF (BUILD_STATIC OR "$ENV{STATIC_TH}" STREQUAL "YES")
+if(BUILD_STATIC)
   ADD_LIBRARY(luaT_static STATIC luaT.h luaT.c)
-  SET_TARGET_PROPERTIES(luaT_static PROPERTIES
-    COMPILE_FLAGS "-fPIC")
-  SET_TARGET_PROPERTIES(luaT_static PROPERTIES
-    PREFIX "lib" IMPORT_PREFIX "lib" OUTPUT_NAME "luaT")
-ENDIF()
-
-SET_TARGET_PROPERTIES(luaT PROPERTIES
-  VERSION   0
-  SOVERSION 0)
+endif()
 
 IF(APPLE)
   SET_TARGET_PROPERTIES(luaT PROPERTIES
@@ -46,5 +37,5 @@
 SET(LUAT_LIBRARIES "${Torch_INSTALL_LIB}/${LUAT_OUTPUT_NAME}")
 SET(LUAT_INCLUDE_DIR "${Torch_INSTALL_INCLUDE}")
 CONFIGURE_FILE(luaTConfig.cmake.in "${CMAKE_CURRENT_BINARY_DIR}/cmake-exports/luaTConfig.cmake")
-INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/cmake-exports/luaTConfig.cmake"
+INSTALL(FILES "${CMAKE_CURRENT_BINARY_DIR}/cmake-exports/luaTConfig.cmake" 
   DESTINATION "${Torch_INSTALL_CMAKE_SUBDIR}")
